curl --request POST \
--url https://developer.synq.io/api/entities/platform-users/v1alpha/list \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--data '
{
"serviceAccountIds": [
"<string>"
],
"platforms": [],
"platformRootEntityIds": [
"<string>"
],
"unclassifiedOnly": true,
"suggestedOnly": true,
"search": "<string>",
"windowDays": 91,
"platformUserIds": [
"<string>"
],
"sources": [
"<string>"
],
"pagination": {
"cursor": "<string>",
"pageSize": 1
}
}
'import requests
url = "https://developer.synq.io/api/entities/platform-users/v1alpha/list"
payload = {
"serviceAccountIds": ["<string>"],
"platforms": [],
"platformRootEntityIds": ["<string>"],
"unclassifiedOnly": True,
"suggestedOnly": True,
"search": "<string>",
"windowDays": 91,
"platformUserIds": ["<string>"],
"sources": ["<string>"],
"pagination": {
"cursor": "<string>",
"pageSize": 1
}
}
headers = {
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
body: JSON.stringify({
serviceAccountIds: ['<string>'],
platforms: [],
platformRootEntityIds: ['<string>'],
unclassifiedOnly: true,
suggestedOnly: true,
search: '<string>',
windowDays: 91,
platformUserIds: ['<string>'],
sources: ['<string>'],
pagination: {cursor: '<string>', pageSize: 1}
})
};
fetch('https://developer.synq.io/api/entities/platform-users/v1alpha/list', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://developer.synq.io/api/entities/platform-users/v1alpha/list",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => json_encode([
'serviceAccountIds' => [
'<string>'
],
'platforms' => [
],
'platformRootEntityIds' => [
'<string>'
],
'unclassifiedOnly' => true,
'suggestedOnly' => true,
'search' => '<string>',
'windowDays' => 91,
'platformUserIds' => [
'<string>'
],
'sources' => [
'<string>'
],
'pagination' => [
'cursor' => '<string>',
'pageSize' => 1
]
]),
CURLOPT_HTTPHEADER => [
"Authorization: Bearer <token>",
"Content-Type: application/json"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://developer.synq.io/api/entities/platform-users/v1alpha/list"
payload := strings.NewReader("{\n \"serviceAccountIds\": [\n \"<string>\"\n ],\n \"platforms\": [],\n \"platformRootEntityIds\": [\n \"<string>\"\n ],\n \"unclassifiedOnly\": true,\n \"suggestedOnly\": true,\n \"search\": \"<string>\",\n \"windowDays\": 91,\n \"platformUserIds\": [\n \"<string>\"\n ],\n \"sources\": [\n \"<string>\"\n ],\n \"pagination\": {\n \"cursor\": \"<string>\",\n \"pageSize\": 1\n }\n}")
req, _ := http.NewRequest("POST", url, payload)
req.Header.Add("Authorization", "Bearer <token>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.post("https://developer.synq.io/api/entities/platform-users/v1alpha/list")
.header("Authorization", "Bearer <token>")
.header("Content-Type", "application/json")
.body("{\n \"serviceAccountIds\": [\n \"<string>\"\n ],\n \"platforms\": [],\n \"platformRootEntityIds\": [\n \"<string>\"\n ],\n \"unclassifiedOnly\": true,\n \"suggestedOnly\": true,\n \"search\": \"<string>\",\n \"windowDays\": 91,\n \"platformUserIds\": [\n \"<string>\"\n ],\n \"sources\": [\n \"<string>\"\n ],\n \"pagination\": {\n \"cursor\": \"<string>\",\n \"pageSize\": 1\n }\n}")
.asString();require 'uri'
require 'net/http'
url = URI("https://developer.synq.io/api/entities/platform-users/v1alpha/list")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n \"serviceAccountIds\": [\n \"<string>\"\n ],\n \"platforms\": [],\n \"platformRootEntityIds\": [\n \"<string>\"\n ],\n \"unclassifiedOnly\": true,\n \"suggestedOnly\": true,\n \"search\": \"<string>\",\n \"windowDays\": 91,\n \"platformUserIds\": [\n \"<string>\"\n ],\n \"sources\": [\n \"<string>\"\n ],\n \"pagination\": {\n \"cursor\": \"<string>\",\n \"pageSize\": 1\n }\n}"
response = http.request(request)
puts response.read_body{
"platformUsers": [
{
"platformUserId": "<string>",
"name": "<string>",
"platform": "DATA_PLATFORM_TYPE_UNSPECIFIED",
"platformRootEntityId": "<string>",
"sources": [
{
"source": "<string>",
"userType": "<string>",
"email": "<string>",
"displayName": "<string>",
"coalesceLogin": true,
"coalesceLoginCurrent": true,
"stateAt": "2023-01-15T01:30:15.01Z"
}
],
"classification": "CLASSIFICATION_UNSPECIFIED",
"lastSeenAt": "2023-01-15T01:30:15.01Z",
"reads": 123,
"writes": 123,
"share": 123,
"weights": [
{
"platform": "DATA_PLATFORM_TYPE_UNSPECIFIED",
"computeUnit": "COMPUTE_UNIT_UNSPECIFIED",
"weights": {
"executionMs": "<unknown>",
"computeMs": "<unknown>",
"bytesScanned": "<unknown>",
"bytesBilled": "<unknown>"
}
}
],
"slices": [
{
"issuer": "DATA_PLATFORM_TYPE_UNSPECIFIED",
"classification": "CLASSIFICATION_UNSPECIFIED",
"serviceAccounts": [
{
"serviceAccountId": "<string>",
"kind": "MATCH_KIND_UNSPECIFIED",
"matcherId": "<string>"
}
],
"person": {
"identity": "<string>",
"personLinkId": "<string>"
},
"countsTowardPopularity": true,
"listedAsFrequentUser": true,
"lastSeenAt": "2023-01-15T01:30:15.01Z",
"signals": {
"issuerShare": 123,
"reads": 123,
"inputs": 123,
"writes": 123,
"activeDays": 123,
"distinctEntities": 123,
"writtenEntities": 123,
"writeCadence": "WRITE_CADENCE_UNSPECIFIED"
}
}
],
"identities": [
"<string>"
],
"evidence": [
{
"kind": "EVIDENCE_KIND_UNSPECIFIED",
"platformUserId": "<string>",
"login": "<string>",
"values": [
"<string>"
],
"text": "<string>"
}
],
"suggested": true
}
],
"summary": {
"classifiedShare": 123,
"countedShare": 123,
"unclassifiedLogins": 123,
"suggestedLogins": 123,
"logins": 123
},
"pageInfo": {
"totalCount": 123,
"count": 123,
"lastId": "<string>"
},
"from": "2023-01-15T01:30:15.01Z",
"to": "2023-01-15T01:30:15.01Z"
}ListPlatformUsers
List the workspace’s logins by their share of the workspace’s activity, highest first. The first page carries a summary of the whole window.
curl --request POST \
--url https://developer.synq.io/api/entities/platform-users/v1alpha/list \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--data '
{
"serviceAccountIds": [
"<string>"
],
"platforms": [],
"platformRootEntityIds": [
"<string>"
],
"unclassifiedOnly": true,
"suggestedOnly": true,
"search": "<string>",
"windowDays": 91,
"platformUserIds": [
"<string>"
],
"sources": [
"<string>"
],
"pagination": {
"cursor": "<string>",
"pageSize": 1
}
}
'import requests
url = "https://developer.synq.io/api/entities/platform-users/v1alpha/list"
payload = {
"serviceAccountIds": ["<string>"],
"platforms": [],
"platformRootEntityIds": ["<string>"],
"unclassifiedOnly": True,
"suggestedOnly": True,
"search": "<string>",
"windowDays": 91,
"platformUserIds": ["<string>"],
"sources": ["<string>"],
"pagination": {
"cursor": "<string>",
"pageSize": 1
}
}
headers = {
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
body: JSON.stringify({
serviceAccountIds: ['<string>'],
platforms: [],
platformRootEntityIds: ['<string>'],
unclassifiedOnly: true,
suggestedOnly: true,
search: '<string>',
windowDays: 91,
platformUserIds: ['<string>'],
sources: ['<string>'],
pagination: {cursor: '<string>', pageSize: 1}
})
};
fetch('https://developer.synq.io/api/entities/platform-users/v1alpha/list', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://developer.synq.io/api/entities/platform-users/v1alpha/list",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => json_encode([
'serviceAccountIds' => [
'<string>'
],
'platforms' => [
],
'platformRootEntityIds' => [
'<string>'
],
'unclassifiedOnly' => true,
'suggestedOnly' => true,
'search' => '<string>',
'windowDays' => 91,
'platformUserIds' => [
'<string>'
],
'sources' => [
'<string>'
],
'pagination' => [
'cursor' => '<string>',
'pageSize' => 1
]
]),
CURLOPT_HTTPHEADER => [
"Authorization: Bearer <token>",
"Content-Type: application/json"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://developer.synq.io/api/entities/platform-users/v1alpha/list"
payload := strings.NewReader("{\n \"serviceAccountIds\": [\n \"<string>\"\n ],\n \"platforms\": [],\n \"platformRootEntityIds\": [\n \"<string>\"\n ],\n \"unclassifiedOnly\": true,\n \"suggestedOnly\": true,\n \"search\": \"<string>\",\n \"windowDays\": 91,\n \"platformUserIds\": [\n \"<string>\"\n ],\n \"sources\": [\n \"<string>\"\n ],\n \"pagination\": {\n \"cursor\": \"<string>\",\n \"pageSize\": 1\n }\n}")
req, _ := http.NewRequest("POST", url, payload)
req.Header.Add("Authorization", "Bearer <token>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.post("https://developer.synq.io/api/entities/platform-users/v1alpha/list")
.header("Authorization", "Bearer <token>")
.header("Content-Type", "application/json")
.body("{\n \"serviceAccountIds\": [\n \"<string>\"\n ],\n \"platforms\": [],\n \"platformRootEntityIds\": [\n \"<string>\"\n ],\n \"unclassifiedOnly\": true,\n \"suggestedOnly\": true,\n \"search\": \"<string>\",\n \"windowDays\": 91,\n \"platformUserIds\": [\n \"<string>\"\n ],\n \"sources\": [\n \"<string>\"\n ],\n \"pagination\": {\n \"cursor\": \"<string>\",\n \"pageSize\": 1\n }\n}")
.asString();require 'uri'
require 'net/http'
url = URI("https://developer.synq.io/api/entities/platform-users/v1alpha/list")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n \"serviceAccountIds\": [\n \"<string>\"\n ],\n \"platforms\": [],\n \"platformRootEntityIds\": [\n \"<string>\"\n ],\n \"unclassifiedOnly\": true,\n \"suggestedOnly\": true,\n \"search\": \"<string>\",\n \"windowDays\": 91,\n \"platformUserIds\": [\n \"<string>\"\n ],\n \"sources\": [\n \"<string>\"\n ],\n \"pagination\": {\n \"cursor\": \"<string>\",\n \"pageSize\": 1\n }\n}"
response = http.request(request)
puts response.read_body{
"platformUsers": [
{
"platformUserId": "<string>",
"name": "<string>",
"platform": "DATA_PLATFORM_TYPE_UNSPECIFIED",
"platformRootEntityId": "<string>",
"sources": [
{
"source": "<string>",
"userType": "<string>",
"email": "<string>",
"displayName": "<string>",
"coalesceLogin": true,
"coalesceLoginCurrent": true,
"stateAt": "2023-01-15T01:30:15.01Z"
}
],
"classification": "CLASSIFICATION_UNSPECIFIED",
"lastSeenAt": "2023-01-15T01:30:15.01Z",
"reads": 123,
"writes": 123,
"share": 123,
"weights": [
{
"platform": "DATA_PLATFORM_TYPE_UNSPECIFIED",
"computeUnit": "COMPUTE_UNIT_UNSPECIFIED",
"weights": {
"executionMs": "<unknown>",
"computeMs": "<unknown>",
"bytesScanned": "<unknown>",
"bytesBilled": "<unknown>"
}
}
],
"slices": [
{
"issuer": "DATA_PLATFORM_TYPE_UNSPECIFIED",
"classification": "CLASSIFICATION_UNSPECIFIED",
"serviceAccounts": [
{
"serviceAccountId": "<string>",
"kind": "MATCH_KIND_UNSPECIFIED",
"matcherId": "<string>"
}
],
"person": {
"identity": "<string>",
"personLinkId": "<string>"
},
"countsTowardPopularity": true,
"listedAsFrequentUser": true,
"lastSeenAt": "2023-01-15T01:30:15.01Z",
"signals": {
"issuerShare": 123,
"reads": 123,
"inputs": 123,
"writes": 123,
"activeDays": 123,
"distinctEntities": 123,
"writtenEntities": 123,
"writeCadence": "WRITE_CADENCE_UNSPECIFIED"
}
}
],
"identities": [
"<string>"
],
"evidence": [
{
"kind": "EVIDENCE_KIND_UNSPECIFIED",
"platformUserId": "<string>",
"login": "<string>",
"values": [
"<string>"
],
"text": "<string>"
}
],
"suggested": true
}
],
"summary": {
"classifiedShare": 123,
"countedShare": 123,
"unclassifiedLogins": 123,
"suggestedLogins": 123,
"logins": 123
},
"pageInfo": {
"totalCount": 123,
"count": 123,
"lastId": "<string>"
},
"from": "2023-01-15T01:30:15.01Z",
"to": "2023-01-15T01:30:15.01Z"
}Authorizations
Bearer authentication header of the form Bearer <token>, where <token> is your auth token.
Body
Only the logins in these service accounts, built-in ones included.
1001 - 128Only the logins on these platforms.
DATA_PLATFORM_TYPE_UNSPECIFIED, DATA_PLATFORM_TYPE_BIGQUERY, DATA_PLATFORM_TYPE_LOOKER, DATA_PLATFORM_TYPE_DBT, DATA_PLATFORM_TYPE_DBT_CLOUD, DATA_PLATFORM_TYPE_DBT_SELF_HOSTED, DATA_PLATFORM_TYPE_SNOWFLAKE, DATA_PLATFORM_TYPE_GCP, DATA_PLATFORM_TYPE_GIT, DATA_PLATFORM_TYPE_GITHUB, DATA_PLATFORM_TYPE_REDSHIFT, DATA_PLATFORM_TYPE_TABLEAU, DATA_PLATFORM_TYPE_AIRFLOW, DATA_PLATFORM_TYPE_CLICKHOUSE, DATA_PLATFORM_TYPE_POSTGRES, DATA_PLATFORM_TYPE_MYSQL, DATA_PLATFORM_TYPE_DATABRICKS, DATA_PLATFORM_TYPE_SQLMESH, DATA_PLATFORM_TYPE_DUCKDB, DATA_PLATFORM_TYPE_TRINO, DATA_PLATFORM_TYPE_ATLAN, DATA_PLATFORM_TYPE_COALESCE, DATA_PLATFORM_TYPE_CASTORDOC, DATA_PLATFORM_TYPE_FIVETRAN, DATA_PLATFORM_TYPE_DAGSTER, DATA_PLATFORM_TYPE_AIRBYTE, DATA_PLATFORM_TYPE_STITCH, DATA_PLATFORM_TYPE_SNOWPLOW, DATA_PLATFORM_TYPE_POWERBI, DATA_PLATFORM_TYPE_THOUGHTSPOT, DATA_PLATFORM_TYPE_SIGMA, DATA_PLATFORM_TYPE_DOMO, DATA_PLATFORM_TYPE_MSSQL, DATA_PLATFORM_TYPE_ORACLE, DATA_PLATFORM_TYPE_ATHENA, DATA_PLATFORM_TYPE_FABRIC, DATA_PLATFORM_TYPE_DB2, DATA_PLATFORM_TYPE_LOOKER_STUDIO, DATA_PLATFORM_TYPE_HEX, DATA_PLATFORM_TYPE_OMNI, DATA_PLATFORM_TYPE_METABASE, DATA_PLATFORM_TYPE_GOOGLE_SHEETS, DATA_PLATFORM_TYPE_GRAFANA, DATA_PLATFORM_TYPE_STREAMLIT, DATA_PLATFORM_TYPE_ASTRATO, DATA_PLATFORM_TYPE_SNOWFLAKE_CORTEX, DATA_PLATFORM_TYPE_SNOWFLAKE_INTELLIGENCE, DATA_PLATFORM_TYPE_CUBE, DATA_PLATFORM_TYPE_CENSUS, DATA_PLATFORM_TYPE_HIGHTOUCH, DATA_PLATFORM_TYPE_WORKATO, DATA_PLATFORM_TYPE_ESTUARY, DATA_PLATFORM_TYPE_DLT, DATA_PLATFORM_TYPE_TERRAFORM, DATA_PLATFORM_TYPE_HEVO, DATA_PLATFORM_TYPE_DATASTREAM, DATA_PLATFORM_TYPE_SYNQ Only the logins on these platform instances.
1001 - 2048Only the logins with a slice no service account takes and no person link or email links.
Only the logins a service account suggestion includes.
A substring of the login, display name or email, ignoring case.
256The days of query history read, back from the current hour. Unset is 30.
x <= 92Only these logins.
10001 - 2048Only the logins these integrations declare.
1001 - 256PlatformUserView is how much of a login a read returns.
PLATFORM_USER_VIEW_UNSPECIFIED, PLATFORM_USER_VIEW_BASIC, PLATFORM_USER_VIEW_FULL Without a page size every matching login is returned.
Show child attributes
Show child attributes
Response
Success
Show child attributes
Show child attributes
On the first page only.
Show child attributes
Show child attributes
Show child attributes
Show child attributes
The window read, [from, to).
"2023-01-15T01:30:15.01Z"
"2024-12-25T12:00:00Z"
A Timestamp represents a point in time independent of any time zone or local calendar, encoded as a count of seconds and fractions of seconds at nanosecond resolution. The count is relative to an epoch at UTC midnight on January 1, 1970, in the proleptic Gregorian calendar which extends the Gregorian calendar backwards to year one.
All minutes are 60 seconds long. Leap seconds are "smeared" so that no leap second table is needed for interpretation, using a 24-hour linear smear.
The range is from 0001-01-01T00:00:00Z to 9999-12-31T23:59:59.999999999Z. By restricting to that range, we ensure that we can convert to and from RFC 3339 date strings.
Examples
Example 1: Compute Timestamp from POSIX time().
Timestamp timestamp; timestamp.set_seconds(time(NULL)); timestamp.set_nanos(0);
Example 2: Compute Timestamp from POSIX gettimeofday().
struct timeval tv; gettimeofday(&tv, NULL); Timestamp timestamp; timestamp.set_seconds(tv.tv_sec); timestamp.set_nanos(tv.tv_usec * 1000);
Example 3: Compute Timestamp from Win32 GetSystemTimeAsFileTime().
FILETIME ft; GetSystemTimeAsFileTime(&ft); UINT64 ticks = (((UINT64)ft.dwHighDateTime) << 32) | ft.dwLowDateTime; // A Windows tick is 100 nanoseconds. Windows epoch 1601-01-01T00:00:00Z // is 11644473600 seconds before Unix epoch 1970-01-01T00:00:00Z. Timestamp timestamp; timestamp.set_seconds((INT64) ((ticks / 10000000) - 11644473600LL)); timestamp.set_nanos((INT32) ((ticks % 10000000) * 100));
Example 4: Compute Timestamp from Java System.currentTimeMillis().
long millis = System.currentTimeMillis(); Timestamp timestamp = Timestamp.newBuilder().setSeconds(millis / 1000) .setNanos((int) ((millis % 1000) * 1000000)).build();
Example 5: Compute Timestamp from Java Instant.now().
Instant now = Instant.now(); Timestamp timestamp = Timestamp.newBuilder().setSeconds(now.getEpochSecond()) .setNanos(now.getNano()).build();
Example 6: Compute Timestamp from current time in Python.
timestamp = Timestamp() timestamp.GetCurrentTime()
JSON Mapping
In JSON format, the Timestamp type is encoded as a string in the RFC 3339 format. That is, the format is "{year}-{month}-{day}T{hour}:{min}:{sec}[.{frac_sec}]Z" where {year} is always expressed using four digits while {month}, {day}, {hour}, {min}, and {sec} are zero-padded to two digits each. The fractional seconds, which can go up to 9 digits (i.e. up to 1 nanosecond resolution), are optional. The "Z" suffix indicates the timezone ("UTC"); the timezone is required. A proto3 JSON serializer should always use UTC (as indicated by "Z") when printing the Timestamp type and a proto3 JSON parser should be able to accept both UTC and other timezones (as indicated by an offset).
For example, "2017-01-15T01:30:15.01Z" encodes 15.01 seconds past 01:30 UTC on January 15, 2017.
In JavaScript, one can convert a Date object to this format using the
standard
toISOString()
method. In Python, a standard datetime.datetime object can be converted
to this format using
strftime with
the time format spec '%Y-%m-%dT%H:%M:%S.%fZ'. Likewise, in Java, one can use
the Joda Time's ISODateTimeFormat.dateTime() to obtain a formatter capable of generating timestamps in this format.
"2023-01-15T01:30:15.01Z"
"2024-12-25T12:00:00Z"